<?php

/*
 
        Formulaire d'édition pour la table : propertyval.

        10/13/2022 12:52

        monmail@fai.com - 2022
         
        Licence libre etc ...
 
*/


include_once "dbconnect.php";
include_once "phpdb/class_propertyval.php";
include_once "phpdb/class_propertyval_ext.php";


function modQuery($add_to, $rem_from = array(), $clear_all = false){
  if ($clear_all){
     $query_string = array();
  }else{
     parse_str($_SERVER['QUERY_STRING'], $query_string);
  }
  
  if (!is_array($add_to)){ $add_to = array(); }
  $query_string = array_merge($query_string, $add_to);
  if (!is_array($rem_from)){ $rem_from = array($rem_from); }
  foreach($rem_from as $key){
     unset($query_string[$key]);
  }
  return http_build_query($query_string);
  }
  

if (isset($_REQUEST['a_id_value']))	$id=$_REQUEST['a_id_value'];
else 
	if (isset($_REQUEST['id']))	$id=$_REQUEST['id'];
	else die("Erreur : _REQUEST['id'] est manquant.");  
				
if (isset($_REQUEST['offset']))
	$offset=$_REQUEST['offset'];
else 
	$offset = '';


if (isset($_REQUEST['a_cle']))
	$cle=$_REQUEST['a_cle'];
else 
	$cle = '';

/*
parse_str($_SERVER['QUERY_STRING'], $query_string);
$query_string['cle'] = $cle;
$userUrl = http_build_query($query_string);
*/

$userUrl = "index.php?".modQuery(array('cle'=>urlencode($cle)));
//echo 'LIEN = <a href="'.urldecode($userUrl).'">'.urldecode($userUrl).'</a>';      


$userUiMessage="";
  
// Class instance
$mypropertyval = new propertyval( $db );



$sqlError = false;

// Sauvegarde 
if(isset($_POST['submitSave'])) 
{ 
    if ($id > 0) {
        $results = $mypropertyval->update( 
$_REQUEST["a_id"], 
$_REQUEST["a_marker_id"], 
$_REQUEST["a_propertyref_id"], 
$_REQUEST["a_value"], 
$_REQUEST["a_datecreated"] ); 

        if ($results === false) {           
            $userUiMessage .= '<div class="editmessageError">Erreur sauvegarde (id='.$id.') :'.$mypropertyval->lasterror.'</div>';        
            $sqlError = true;
		}
        else 
			$userUiMessage .= '<div class="editmessageInfo">Sauvegarde effectuée (id='.$id.')</div>';        
    }
    else 
    {
        $results = $mypropertyval->insert( 
$_REQUEST["a_marker_id"], 
$_REQUEST["a_propertyref_id"], 
$_REQUEST["a_value"], 
$_REQUEST["a_datecreated"]  ); 
        echo '<div class="editmessage">';
        if ($results === false) {
            $userUiMessage .= '<div class="editmessageError">Erreur de création :'.$mypropertyval->lasterror.'</div>';        
            $sqlError = true;
		}
        else {
            $id=$mypropertyval->lastInsertId;
			$userUiMessage .= '<div class="editmessageInfo">Création effectuée (id='.$id.')</div>';
        }        
    }
}

// Suppression
if(isset($_POST['submitDelete'])) 
{ 
    if ($id > 0) {
        $results = $mypropertyval->delete( $id ); 

        if ($results === false) {
			$userUiMessage .= '<div class="editmessageError">Erreur Suppression (id='.$id.') :'.$mypropertyval->lasterror.'</div>';
			$sqlError = true;
		}
        else {
			$userUiMessage .= '<div class="editmessageInfo">Suppression effectuée (id='.$id.')</div>';
			$id = -1;
        }
        
    }
}

// Select reccord by id :
if ($sqlError === false ) {
	
	if ( isset($_POST['submitSave']) || isset($_POST['submitDelete']) ) 
		$results = $mypropertyval->select( $id );
	else {
		switch ($offset) {
			case '_PREV':
				$results = $mypropertyval->selectPrev( $id );
				$id = $results[0]['a.id'];
				break;
			case '_NEXT':
				$results = $mypropertyval->selectNext( $id );
				$id = $results[0]['a.id'];
				break;
			default:
				$results = $mypropertyval->select( $id );
				break;
		}				
	}
		
	if ($_REQUEST['cle'] != $results[0]["a.cle"]) {
		echo '***************Erreur de clé.';
		//print_r($_REQUEST);
		//echo 'cle='.$_REQUEST['cle'].'<br>';
		//echo 'dbcle = '.$results[0]["a.cle"].'<br>';
		//die;
	}
				
		
	if ($results === false) {           
		$userUiMessage .= '<div class="editmessageError">Erreur Sql : '.$mypropertyval->lasterror.'</div>';        
		$sqlError = true;
	}
	/*if ( empty($results) ) {           
		$userUiMessage .= '<div class="editmessageInfo">Cet enregistrement n\'existe plus. id = '.$id.'  </div>';        
		$sqlError = true;
	}
	*/	
}
else { 	
		$results[0]["a.id"] = $_REQUEST['a_id'];	
		$results[0]["a.marker_id"] = $_REQUEST['a_marker_id'];
		$results[0]["a.propertyref_id"] = $_REQUEST['a_propertyref_id'];
		$results[0]["a.value"] = $_REQUEST['a_value'];
		$results[0]["a.datecreated"] = $_REQUEST['a_datecreated'];
		
	}

$recordcount = $mypropertyval->getCount();

echo '<div class="formtable">';

$protocol = $_SERVER['REQUEST_SCHEME'];
$host     = $_SERVER['HTTP_HOST'];
$script   = $_SERVER['SCRIPT_NAME'];
$params   = $_SERVER['QUERY_STRING'];

$currentUrl = $protocol . '://' . $host . $script . '?' . $params;
 
// xxx  fix enctype
echo '<form id="editform" class="formedit pure-form pure-form-aligned" method="post" action="'.$currentUrl.'"  enctype="multipart/form-data" >';

echo '<fieldset>';

echo '<legend style="display:inline-block" class="titleedit"><span title="Valeurs des propriétés d´un marker" class="titleedit">Valeurs</span> #'.($id==-1?'?':$id).'/'.$recordcount['count'];

echo '<div style="font-size:80%; float:right; display:inline-block;">'.$userUiMessage.'</div>';

echo '</legend>';
?>

<input type="hidden" readonly name="a.id.value" value="<?php echo $results[0]["a.id"]; ?>" >

<div class="pure-control-group"><label for="aligned-name">Id</label>
		<input type="{{edithidden}}" readonly name="a.id" value="<?php echo $results[0]["a.id"]; ?>" 		
		style="width:12em;" ><span class="pure-form-message-inline"></span>
</div>
		
		<div class="pure-control-group"><label title="Identifiant du marker" for="aligned-name">Marker</label>
	
					
			
			
				<input type="hidden"  name="a.marker_id" id="a_marker_id" 
				value="<?php echo $results[0]["a.marker_id"]; ?>" 
				style="width:12em;" 
				>
				<input readonly type="text" style="width:{{fkeditlen}}em;"  id="valback_a_marker_id"  value="<?php echo ($results[0]["b1.name"]) ;?>">
				<div style="display:inline-block; color:red">*</div>
				<a class="selectlist" valuetable="marker" valuefield="id" valuebackfield="a_marker_id" valuebackval="valback_a_marker_id" href="#" >Select</a>	
			
						
			<span class="pure-form-message-inline"></span>	
								
		</div>
		
		<div class="pure-control-group"><label title="Propriété" for="aligned-name">Propriété</label>
	
					
			
			
				<input type="hidden"  name="a.propertyref_id" id="a_propertyref_id" 
				value="<?php echo $results[0]["a.propertyref_id"]; ?>" 
				style="width:12em;" 
				>
				<input readonly type="text" style="width:{{fkeditlen}}em;"  id="valback_a_propertyref_id"  value="<?php echo ($results[0]["c2.name"]) ;?>">
				<div style="display:inline-block; color:red">*</div>
				<a class="selectlist" valuetable="propertyref" valuefield="id" valuebackfield="a_propertyref_id" valuebackval="valback_a_propertyref_id" href="#" >Select</a>	
			
						
			<span class="pure-form-message-inline"></span>	
								
		</div>
		
		<div class="pure-control-group"><label title="Valeur de cette propriété" for="aligned-name">Valeur</label>
	
			
						
			
				<textarea  text rows="8" cols="60" name="a.value" rows="4" cols="30" ><?php if ( $results[0]["a.value"] !='') echo $results[0]["a.value"]; else echo ''; ?></textarea>
			
						
			<span class="pure-form-message-inline"></span>	
								
		</div>
		
		<div class="pure-control-group"><label title="Date de création ou modification" for="aligned-name">Modifié le</label>
	
			
			
			
				<input type="text" readonly class="" name="a.datecreated" id="a_datecreated" 
				value="<?php if ( $results[0]["a.datecreated"] !='') echo $results[0]["a.datecreated"]; else echo ''; ?>"
				style="width:12em;" 
				>			
				<div style="display:inline-block; color:red"> </div>
				
			
						
			<span class="pure-form-message-inline"></span>	
								
		</div>

<?

echo ' <div class="pure-controls">'."\n";
echo '<button type="submit" name = "submitSave" class="formbutton xpure-button xpure-button-primary">Enregistrer</button>'."\n";
$confirmBox = "onclick=\"return confirm('Etes vous sûr de vouloir supprimer cet article ?')\"";
if ($id > 0)
    echo '<button type="submit" name = "submitDelete" class="formbutton xpure-button xpure-button-primary" '.$confirmBox.'  >Supprimer</button>'."\n";


parse_str($_SERVER['QUERY_STRING'], $query_string);

if ($id != -1 and $id > $recordcount['minid'] ) { 	
	$urlPrev='';
	$query_string['id'] = $id;
	$query_string['offset'] = '_PREV';
	$paramPrev = http_build_query($query_string);
	$urlPrev = $protocol . '://' . $host . $script . '?' . $paramPrev;
	echo "<a class='formbutton' href='$urlPrev'>Précédent</a>\n";
}
else echo "<a class='formbutton' style='color:gray; pointer-events: none' href=''>Précédent</a>\n";
 
if ($id != -1 and $id < $recordcount['maxid']  ) { 
	$urlNext='';
	$query_string['id'] = $id;
	$query_string['offset'] = '_NEXT';
	$paramNext = http_build_query($query_string);
	$urlNext = $protocol . '://' . $host . $script . '?' . $paramNext;
	echo "<a class='formbutton' href='$urlNext'>Suivant</a>\n";
}
else echo "<a class='formbutton' style='color:gray; pointer-events: none' href=''>Suivant</a>\n";

    
echo '</div>'."\n";
echo '</fieldset>'."\n";
echo '</form>'."\n";

echo '</div>';

?>


<script type="text/javascript">
	
	$(document).ready(function(){
		
		$(".selectlist").on("click", function() {			
			startModal('selectplaceholder');									
			//alert("Id du champ à remplir au retour : [" + $(this).attr('valuebackval')  + "]");
			var url = "phpui/select_" + $(this).attr('valuetable') + ".php?valuebackfield=" + $(this).attr('valuebackfield') + '&valuebackval=' + $(this).attr('valuebackval');
			
			$('#selectplaceholder').load(url, function() {
				$('#selectplaceholder').css("background-color", "white");
				$('#selectplaceholder').css("border", "1px solid #034668");
				//box-shadow: 5px 10px 12px -4px rgba(0,0,0,0.75);
				//-webkit-box-shadow: 5px 10px 12px -4px rgba(0,0,0,0.75);
				//-moz-box-shadow: 5px 10px 12px -4px rgba(0,0,0,0.75);
				$('#selectplaceholder').css("box-shadow", "5px 10px 12px -4px rgba(0,0,0,0.75)");				
				$('#selectplaceholder').css("border-radius", "7px");
			});			
			
		});
	});

	function startModal(id) {
		$("body").prepend(
			"<div id='PopupMask' style='position:fixed;width:100%;height:100%;z-index:10;background-color:gray;'></div>"+
			"<div style='position: fixed;top: 50%;left: 50%; transform: translate(-50%, -50%);' "+
				"id='selectplaceholder'><img  width='180' height='60' src='img/loading.gif'></div>");
		$("#PopupMask").css('opacity', 0.5);  
		$("#"+id).data('saveZindex', $("#"+id).css( "z-index"));
		$("#"+id).data('savePosition', $("#"+id).css( "position"));
		$("#"+id).css( "z-index" , 11 );
		$("#"+id).css( "position" , "fixed" );
	}

</script>

<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
<link rel="stylesheet" href="https://code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">

<script>

	// Disable autofill
	$(".datepicker").prop("autocomplete", "off");

	$( function() {
		
		$.datepicker.regional['fr'] = {
				yearRange: '1:2099',
				changeMonth: true,
				changeYear: true,
				closeText: 'Fermer',
				prevText: '&#x3c;Préc',
				nextText: 'Suiv&#x3e;',
				currentText: 'Aujourd\'hui',
				monthNames: ['Janvier','Fevrier','Mars','Avril','Mai','Juin',
				'Juillet','Aout','Septembre','Octobre','Novembre','Decembre'],
				monthNamesShort: ['Jan','Fev','Mar','Avr','Mai','Jun',
				'Jul','Aou','Sep','Oct','Nov','Dec'],
				dayNames: ['Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi'],
				dayNamesShort: ['Dim','Lun','Mar','Mer','Jeu','Ven','Sam'],
				dayNamesMin: ['Di','Lu','Ma','Me','Je','Ve','Sa'],
				weekHeader: 'Sm',
				dateFormat: 'dd/mm/yy',
				firstDay: 1,
				/*isRTL: false,*/
				/*showMonthAfterYear: false,*/
				/*yearSuffix: '',*/
				/*minDate: 0,*/
				/*maxDate: '+12M +0D',*/
				numberOfMonths: 1,
				showButtonPanel: true
			};
						
		$.datepicker.setDefaults($.datepicker.regional['fr']);
				
		$(".datepicker" ).datepicker().on("show", function() {
							var formDate = $(this).val()							
							$(this).val(formDate).datepicker('update');
						});
								
	} );

	$("#over").remove();
	
	// Page quit confirmation
	var form = $('#editform'),
	  original = form.serialize()

	form.submit(function(){
		$('body').append('<div id="over" style="background:rgba(0,0,0, 0.05); position:fixed; top:0; left:0; width:100%; height:100%;"> <img style="position:absolute; top:0; left:0; right:0; bottom:0; margin:auto;"  width="180" height="60" src="img/loading.gif"> </div> ');
		window.onbeforeunload = null
	})

	window.onbeforeunload = function(){
	  if (form.serialize() != original)
		return "Confirmez-vous l'abandon de vos modifications ?"
	}

</script>
  
